<template>
  <div class="fixed top-0 z-30 w-full">
    <div
      :class="isScrollOver ? 'bg-white' : 'bg-header'"
      class="flex justify-center transition-colors"
    >
      <div v-loading="isLoading" class="header-height">
        <div v-if="!logoForDisplay.IsHidden" class="logo">
          <nuxt-link to="/">
            <img
              class="w-[80px] xl:w-auto max-w-[108px]"
              :src="logoForDisplay.ImagePath"
              alt="logo"
              loading="lazy"
            />
          </nuxt-link>
        </div>
        <div class="flex flex-col items-end resize-menu pt-[16.5px]">
          <ul class="flex items-center order-1 gap-[.4rem]">
            <li v-if="!homeTab.IsHidden" class="nav-item">
              <nuxt-link
                class="text-inherit h-full flex items-center mx-[9px] py-[9px]"
                to="/"
                :class="{ 'active-menu': tabSelected === '/' }"
                :id="ID.TAB_TYPE.HOME"
                >{{ $t("home") }}
              </nuxt-link>
            </li>
            <li
              v-for="tab in menuTabHeaders"
              :key="tab"
              class="nav-item"
              @mouseover="productListFeatureHover(tab.TabType, tab.TabURL)"
              @mouseleave="isFeatureContentEnabled = false"
            >
              <nuxt-link
                class="text-inherit h-full flex items-center mx-[8px] py-[9px] relative"
                :to="tab.TabURL"
                :class="{
                  'active-menu': tabSelected === tab.TabURL?.toLowerCase(),
                }"
                :id="ID.TAB_TYPE[tab.TabLanguage]"
              >
                <div class="flex items-center pointer-events-none">
                  {{ $t(tab.TabLanguage) }}
                </div>
              </nuxt-link>
            </li>
            <li v-if="isAllowPromotionTab" class="nav-item">
              <nuxt-link
                to="/promotion"
                :class="{ 'active-menu': tabSelected === '/promotion' }"
                :id="ID.TAB_TYPE.PROMOTION"
                class="text-inherit hover:hover-header-item h-full flex items-center ml-[9px] py-[9px]"
                >{{ $t("promotion") }}</nuxt-link
              >
            </li>
          </ul>
          <div
            id="user-nav-container"
            class="flex items-center space-x-4 text-base"
          >
            <div>
              <nuxt-link
                v-if="!facebook.IsHidden && facebook.IsHidden !== undefined"
                :to="facebook.HyperLink"
                class="cursor-pointer px-4 py-1.5 h-7 fb-btn rounded-2xl bg-white border border-[#4857E5] --textBtn flex justify-center items-center relative"
                target="_blank"
              >
                <div>
                  <img :src="getAssetImage(`assets/theme/common/icon/facebook.gif`)" class="w-[80px] h-[16px]">
                </div>
                <div class="star-icon absolute">
                  <img :src="getAssetImage(`assets/theme/common/icon/star.gif`)" class="w-[24px] h-[24px]">
                </div>
              </nuxt-link>
            </div>
            <template v-if="auth">
              <template v-if="isCashPlayer && isShowDepositWithdrawal">
                <china-transaction-navigation />
              </template>
              <china-profile-information
                :username="username"
                :is-referral-enabled="referralEnabled"
                :is-promotion-tab-enabled="isAllowPromotionTab"
                :is-suspended="isSuspendedAccount"
              />
            </template>
            <div v-else class="flex items-center text-[12px] gap-1 login-form">
              <el-form
                ref="loginFormRef"
                :model="loginFormData"
                :rules="loginRules"
                inline
              >
                <el-form-item class="header__input" prop="Username">
                  <el-input
                    v-model="loginFormData.Username"
                    type="text"
                    :placeholder="$t('username')"
                  />
                </el-form-item>
                <el-form-item class="header__input" prop="Password">
                  <el-input
                    v-model="loginFormData.Password"
                    type="password"
                    :placeholder="$t('password')"
                  />
                </el-form-item>
                <el-form-item v-if="!clientCaptcha.IsHidden" prop="Captcha">
                  <div id="captcha-button">
                    <div id="captcha-pop-up-verify">
                      <template
                        v-if="
                          !captchaErrorMsg.length &&
                          loginFormData.Captcha.length == 5 &&
                          !isDialogVisible
                        "
                      >
                        <i class="relative w-[18px] h-[18px]">
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                              )
                            "
                            alt="verify icon success"
                            loading="lazy"
                          />
                        </i>
                        <span class="w-[146px]">{{
                          $t("successful_verification")
                        }}</span>
                      </template>
                      <template v-else>
                        <div
                          class="flex items-center justify-center gap-1"
                          @click="isDialogVisible = true"
                        >
                          <i class="relative w-[18px] h-[18px]">
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/light_flexible_1/desktop/images/menu/capcha.png'
                                )
                              "
                              alt="verify icon"
                              loading="lazy"
                            />
                          </i>
                          <span class="w-[90px] truncate">{{
                            $t("click_to_verify")
                          }}</span>
                        </div>
                      </template>
                    </div>
                  </div>
                </el-form-item>
                <el-button
                  id="login-btn"
                  :loading="isLoginProccessing"
                  round
                  type="primary"
                  class="flex items-center justify-center text-white"
                  @click="submitLogin(loginFormRef)"
                  >{{ $t("capital_login") }}
                </el-button>
              </el-form>
              <nuxt-link
                v-if="!register.IsHidden"
                to="/register"
                class="secondary-button"
                :id="ID.SIGNUP"
                >{{ $t("joinnow") }}</nuxt-link
              >
              <nuxt-link
                v-if="!agentCooperation.IsHidden"
                to="/agent-cooperation"
                class="secondary-button"
                >{{ $t("agent_cooperation") }}</nuxt-link
              >
            </div>
          </div>
        </div>
      </div>
      <div
        id="feature-content-nav"
        :class="[
          isFeatureContentEnabled ? 'translate-y-0' : '-translate-y-full',
        ]"
        class="fixed pt-[140px] h-[390px] left-0 top-0 z-[18] w-full nav-background transition-all duration-200 ease-in-out"
        :style="`background:url(${getAssetImage(
          'assets/theme/common/images/product-hover-bg.png'
        )})`"
        @mouseover="isFeatureContentEnabled = true"
        @mouseleave="isFeatureContentEnabled = false"
      >
        <china-game-dropdown :games="filterProductFeature" />
      </div>
    </div>
  </div>
  <el-dialog
    v-model="isDialogVisible"
    align-center
    destroy-on-close
    :show-close="false"
    custom-class="p-[15px] captcha-dialog"
    width="320px"
    @open="loginFormData.Captcha = ''"
    @close="loginFormRef?.validateField('Captcha')"
  >
    <utils-client-captcha
      v-if="!clientCaptcha.IsHidden"
      v-model:captcha="loginFormData.Captcha"
      v-model:dialogVisible="isDialogVisible"
      :get-error-message="getCaptchaErrorMsg"
      :is-invalid="captchaErrorMsg.length > 0"
    />
  </el-dialog>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, ref } from "vue";
import _ from "lodash";
import { store } from "@/store";
import {
  handleReloadRoute,
  handleGameEntryOpenWindow,
  useHeaderComponent,
} from "@/composables/useTheme";
import { GameBsi } from "@/models/bsiGameList";
import useMenu from "@/composables/useMenu";
import useLogin from "@/composables/useLogin";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { clientCaptcha } from "@/composables/captcha/useCaptcha";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

export default defineComponent({
  name: "Header",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    isScrollOver: {
      type: Boolean,
      required: true,
    },
  },
  setup() {
    const {
      menuTabHeaders,
      tabSelected,
      isLoading,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      referralEnabled,
      agentCooperation,
      auth,
      productListFeature,
      productListFeatureProperty,
      username,
      isSuspendedAccount,
      register,
      homeTab,
    } = useHeaderComponent();
    const filterProductFeature = ref<GameBsi[]>();
    const productListFeatureHover = (type: string, link: string) => {
      filterProductFeature.value = _.uniqBy(
        productListFeature.value
          ?.map((item) => new GameBsi(item))
          .filter((item) => {
            switch (item.TabType) {
              case "Cock Fight":
                item.CategoryName = "COCK_FIGHT";
                break;
              case "Poker":
                item.CategoryName = "POKER";
                break;
              case "Lottery":
                item.CategoryName = "LOTTERY";
                break;
              default:
                break;
            }
            const baseURL = `${window.location.origin}`;
            const isHoverCategory =
              item.CategoryName === _.toUpper(_.replace(type, " ", "_")) &&
              item.EnglishGameName;
            let disallowedGame = ["sexybaccarat"];

            if (item.CategoryName === "LIVE_CASINO") {
              item.LinkOption = auth ? "" : `${baseURL}/login`;
            } else if (item.CategoryName === "GAMES") {
              disallowedGame = ["lionking", "pragmaticplayjay"];
              item.LinkOption = `${baseURL}${link}/${item.GameProviderName}`;
              return (
                isHoverCategory &&
                !disallowedGame.includes(item.GameProviderNameForDisplay)
              );
            } else {
              item.LinkOption = auth
                ? `${baseURL}/Game/${item.GameId}?tab=${_.replace(
                    link,
                    "/",
                    ""
                  )}`
                : `${baseURL}/login`;
            }
            if (item.CategoryType === "isSport") {
              disallowedGame = ["sabaentrancenotusing"];
              return (
                isHoverCategory &&
                !disallowedGame.includes(item.GameNameForDisplay)
              );
            }

            return (
              isHoverCategory &&
              !disallowedGame.includes(item.GameNameForDisplay)
            );
          }),
        "GameProviderName"
      );
      if (filterProductFeature.value?.length === 0) {
        isFeatureContentEnabled.value = false;
      } else {
        isFeatureContentEnabled.value =
          !productListFeatureProperty.value.IsHidden;
      }
    };
    const { isCashPlayer, isShowDepositWithdrawal } = useMenu();
    const { ...props } = useLogin();
    const isDialogVisible = ref(false);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const logoForDisplay = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "logo"
        )
    );
    const { getAssetImage } = commonHelper;
    const facebook = computed(() =>
      featuresToggleHelper.getThemePropertyFromApi(
        EnumThemePropertyKey.HtmlId,
        "facebook_link"
      )
    );
    return {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      referralEnabled,
      logoForDisplay,
      agentCooperation,
      auth,
      handleReloadRoute,
      handleGameEntryOpenWindow,
      isCashPlayer,
      isShowDepositWithdrawal,
      username,
      isSuspendedAccount,
      ...props,
      clientCaptcha,
      isDialogVisible,
      EnumEntranceLocation,
      getAssetImage,
      register,
      facebook,
      homeTab,
    };
  },
});
</script>
<style lang="postcss" scoped>
.el-form-item.el-form-item--default.is-required {
  margin-right: 4px;
}
.bg-header {
  background: var(--background1);
}

.header-height {
  @apply w-[1200px] h-[100px] flex justify-between items-center relative gap-2;
  z-index: 19;
}

.nav-item {
  @apply cursor-pointer relative font-medium;
}

.resize-menu .nav-item > a {
  display: inline-block;
  position: relative;
  transition: all 0.3s ease-in-out;
}

.nav-item .active-menu,
.nav-item:hover > a,
.nav-item:hover > div > a,
.nav-item:hover > div > span {
  color: var(--selected);
  margin-bottom: 8px;
}

.nav-item > a::before,
.nav-item > div > a::before {
  background-color: var(--selected);
  top: 38px;
  content: "";
  height: 2px;
  left: 0;
  position: absolute;
  width: 100%;
  transition: all 400ms ease;
  scale: 0;
  border-radius: 3px;
}

.nav-item .active-menu::before,
.nav-item:hover > a::before,
.nav-item:hover > div > a::before {
  scale: 1;
}

#login-btn {
  @apply px-3 border-0 mr-1;
  height: 28px;
  font-size: inherit;
  background: var(--primary-button);
}

#captcha-button {
  height: 28px;
  display: flex;
  background-color: rgba(108 123 168 / 0.5);
  padding: 0.5rem;
  border-radius: 9999px;
  align-items: center;
  cursor: pointer;
  position: relative;
}

#captcha-pop-up-verify {
  cursor: pointer;
  display: flex;
  justify-content: center;
  align-items: center;
  border: unset;
  background: transparent;
  color: #fff;
  margin: 0;
  gap: 0.25rem;
}

#sport-live-icon {
  width: 34px;
  height: 16px;
}

.secondary-button {
  @apply rounded-full h-[28px] flex items-center justify-center px-3 bg-[#f6f9ff];
}

#feature-content-nav :deep(.swiper-button-next) {
  right: 5px;
}
#feature-content-nav :deep(.swiper-button-prev) {
  left: 5px;
}
</style>

<style scoped>
:deep(.swiper-wrapper) {
  align-items: center;
}
:deep(.star-icon) {
  right: -11px;
}
</style>
